package org.rcisoft.business.blesson.entity;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.validator.constraints.Length;
import org.rcisoft.core.entity.IdEntity;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;

/**
 * Created with CodeGenerator on .
 */
@Entity
@Table(name = "b_lesson")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class BLesson extends IdEntity<BLesson> {
    private static final long serialVersionUID = -4327021174023243830L;

    /*课程编号*/
    private String code;
    /*课程名称*/
    @Length(min = 1,max = 50,message = "长度最小为1,最大为50")
    private String lessonName;
    /*默认封面图片url*/
    private String defaultUrl;

    private String classHour;//课时

    private String credits;//学分

    @Transient
    private String directionId;//课程方向ID

    @Transient
    private String directionName;//课程方向名称

    @Transient
    private String directionCode;//课程方向编号

    public BLesson(String code) {
        this.code = code;
    }

    public BLesson(String code, String lessonName, String classHour, String credits) {
        this.code = code;
        this.lessonName = lessonName;
        this.classHour = classHour;
        this.credits = credits;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        BLesson bLesson = (BLesson) o;

        if (code != null ? !code.equals(bLesson.code) : bLesson.code != null) return false;
        return lessonName != null ? lessonName.equals(bLesson.lessonName) : bLesson.lessonName == null;
    }

}

