package org.rcisoft.business.bsl.entity;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.validator.constraints.Length;
import org.rcisoft.core.entity.IdEntity;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.Date;

/**
* Created with CodeGenerator on 2017/07/12.
*/
@Entity
@Table(name = "b_sl")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class BSl extends IdEntity<BSl> {

    private static final long serialVersionUID = 263672387949424361L;

    public BSl(String code, String lessonCode, String teacherCode, String termCode) {
        this.code = code;
        this.lessonCode = lessonCode;
        this.teacherCode = teacherCode;
        this.termCode = termCode;
    }

    public BSl(String code, String delFlag, String flag) {
        this.code = code;
        this.delFlag = delFlag;
        this.flag = flag;
    }

    private String code;//课序号
    private String lessonCode;//课程编号
    private String teacherCode;//教师编号
    private String termCode;//学期编号
    //private String isOnline;//是否上线，（0：待上线，1：已上线，2：已下线）
    private String slCoverUrl;  //课程封面
    @Length(min = 1,max = 200,message = "长度最小为1,最大为200")
    private String slNotes;  //课程简介
    private String isRecommend;  //是否推荐
    private Date recommendDate;  //推荐日期
    private Integer recommendOrder;  //推荐序号

    @Length(min = 1,max = 200,message = "长度最小为1,最大为200")
    private String recommendCourse;  //推荐原因

    private String gitLabProjectId;   //gitlab项目id

    private String gitLabProjectName;  //gitlab项目名

    private String classHour;//课时

    private String credits;//学分

    private String auditStatus;//审核状态 0:待发布,1审核中,2已发布,3已驳回

     @Transient
    private String teacherName;// 教师姓名

    @Transient
    private String lessonName;//课程名称

    @Transient
    private String termName;//学期名称

    @Transient
    private String studyNum;//在学人数

    @Transient
    private String directionId;//课程方向ID

    @Transient
    private String directionName;//课程方向名称

}

