package org.rcisoft.business.tquestion.dao;

import org.apache.ibatis.annotations.*;
import org.rcisoft.business.tquestion.entity.TQuestionOptions;
import org.rcisoft.core.base.BaseMapper;
import org.rcisoft.business.tquestion.entity.TQuestion;
import org.rcisoft.core.model.PersistModel;
import org.springframework.stereotype.Repository;


import java.util.List;

/**
* Created with yangzhaojun on 2018-1-15 19:49:07.
*/
@Repository
public interface TQuestionRepository extends BaseMapper<TQuestion> {

    /**
    * 分页查询 tQuestion
    *
    */
    @Select("<script>select * from t_question where 1=1 "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> "
            + "<if test=\"qtype != null and qtype != '' \">and qtype = #{qtype} </if>"
            + "<if test=\"qtitle != null and qtitle != '' \">and qtitle LIKE CONCAT ('%',#{qtitle},'%')</if>"
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<TQuestion> queryTQuestionsByPagination(TQuestion tQuestion);


    @Select("<script>select * "
            +"from t_question tq"
            +"left join t_question_options tqo on tqo.qid = tq.business_id"
            +"where 1=1"
            +"<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            +"<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> "

            +"<if test=\"business_id != null and business_id != ''\">and business_id = #{business_id}</if></script>")
    List<TQuestion> queryTQuestions(TQuestion tQuestion);

    @Update("<script> update t_question set del_flag = 1 , flag = 0 where FIND_IN_SET(business_id,#{idInfoList})</script>")
    int deleteByIds(String idInfoList);

    @Insert("<script>INSERT INTO t_question_options " +
            "(business_id,qid,describe,alias)VALUES " +
            "<foreach collection=\"list\" item=\"item\" separator=\",\">" +
            "( #{item.businessId},#{item.qid},#{item.describe},#{item.alias})" +
            "</foreach></script>")
    int insertOptionsList(List<TQuestionOptions> optionList);
}

