package org.rcisoft.business.tquestion.service;

import org.rcisoft.business.tquestion.entity.TQuestion;
import org.rcisoft.business.tquestion.entity.TQuestionOptions;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.aop.PageUtil;

import java.util.List;
import java.util.Map;

/**
 * Created by yangzhaojun on 2018-1-15 19:49:07.
 */
public interface TQuestionService {

    /**
    * 保存 
    * @param tQuestion
    * @return
    */
    PersistModel save(TQuestion tQuestion, List<Map<String,Object>> questionOptions);

    /**
    * 逻辑删除 
    * @param id
    * @return
    */
     int remove(String id, String token);

    /**
    * 修改 
    * @param tQuestion
    * @return
    */
    PersistModel merge(TQuestion tQuestion);

    /**
    * 根据id查询 
    * @param id
    * @return
    */
    TQuestion findById(String id);

    /**
    * 分页查询 
    * @param tQuestion
    * @return
    */
    List<TQuestion> findAllByPagination(PageUtil<TQuestion> paginationUtility,
                                        TQuestion tQuestion);


    List<TQuestion> queryTQuestions(TQuestion tQuestion);

    int removeByIds(String idInfoList);

    PersistModel saveoption(TQuestionOptions tQuestionOptions);

    int removeOption(String id, String token);
}
