package org.rcisoft.core.util;

import java.io.*;

public class CompileUtil {
	/**
     * @param code 代码
     * @param fileName 文件名
     * @param fileUrl  文件所在目录
     * @return
     */
    public static String executeJavaCode(String code,String fileName,String fileUrl) throws Exception {
    	writeCodeToFile(code,fileName,fileUrl);//写文件
        File file = new File(fileUrl+fileName+".java");//java文件
        //等待文件写完
        while(!file.exists()) {
            Thread.sleep(10);
        }
        File dir = new File(fileUrl);
        String os = System.getProperty("os.name");
		String java,java_class;
		//判断操作系统
		if (os.toLowerCase().startsWith("win")) {
			java = "c:\\Windows\\System32\\cmd.exe /c javac -encoding utf-8 "+fileName+".java";
            java_class = "c:\\Windows\\System32\\cmd.exe /c java "+fileName;
		} else {
            java = "javac -encoding utf-8 "+fileName+".java";
            java_class = "java "+fileName;
		}

        Runtime r1 = Runtime.getRuntime();
        Process p1 = null;
        Boolean comResult1 =true;
        String result="";
        try {
            //先编译java文件
            p1 = r1.exec(java, null, dir);
            InputStreamReader ir = new InputStreamReader(p1.getInputStream(),"GBK");
            LineNumberReader input = new LineNumberReader(ir);
            StringBuilder sb = new StringBuilder();
            boolean firstLine = true;
            String line;
            //取出输出结果
            while ((line = input.readLine()) != null) {
                comResult1 = false;
                if(!firstLine){
                    sb.append(System.getProperty("line.separator"));
                }else{
                    firstLine = false;
                }
                sb.append(line);
            }
            input.close();
            ir.close();
            result = sb.toString();
            /*if(input.readLine()!=null) {
            	comResult1 = false;
            }*/
            if(!comResult1) {

                return result;
            }
            String classUrl = fileUrl+fileName+".class";
            File classFile = new File(classUrl);
            while(!classFile.exists()) {
                Thread.sleep(10);
                if(!comResult1) {
                    break;
                }
            }
            Runtime r2 = Runtime.getRuntime();
            Process p2 = null;
            p2 = r2.exec(java_class, null, dir);
            InputStreamReader isr = new InputStreamReader(p2.getInputStream(),"GBK");
            LineNumberReader lnr = new LineNumberReader(isr);

            StringBuilder sbl = new StringBuilder();
            boolean firstLine2 = true;
            String line2;

            while ((line2 = lnr.readLine()) != null) {
                if(!firstLine2){
                    sbl.append(System.getProperty("line.separator"));
                }else{
                    firstLine2 = false;
                }
                sbl.append(line2);
            }
            lnr.close();
            isr.close();
            result = sbl.toString();
            file.delete();
            classFile.delete();
            p2.waitFor();
            p2.destroy();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return result;
    }

    public static void writeCodeToFile(String code,String fileName,String fileUrl) throws Exception{
        File file = new File(fileUrl+fileName+".java");
        if(!file.getParentFile().exists()){
            file.getParentFile().mkdirs();
        }

        Writer out = new FileWriter(file);
        out.write(code);
        out.close();

    }
}
